package com.example.mylog;


import java.text.SimpleDateFormat;
import java.util.Date;
import android.app.Service;
import android.content.Intent;
import android.database.Cursor;
import android.os.IBinder;
import android.provider.CallLog;
import android.util.Log;



public class PhoneService extends Service {
	
	private static final String TAG = PhoneService.class.getSimpleName();
	public DBAdapter db;


	
	// Specify formatting of data and time --> looks awesome :D
	SimpleDateFormat formatDate = new SimpleDateFormat("dd-MM-yyyy");
	SimpleDateFormat formatTime = new SimpleDateFormat("HH:mm:ss");
	
	
	// Specify formatting for duration --> looks even more awesome :D	
	public String formatDuration(String input) {
		
		long seconds = Long.parseLong(input);
	    StringBuffer buf = new StringBuffer();
	    Log.d(TAG, input);

	    int h = (int) Math.floor(seconds / 3600);
	    int m = (int) Math.floor((seconds - h * 3600) / 60);
	    int s = (int) seconds - h - m;

	    buf
	        .append(String.format("%02d", h))
	        .append(":")
	        .append(String.format("%02d", m))
	        .append(":")
	        .append(String.format("%02d", s));

	    return buf.toString();
	}	
	
	// Specify interpretation of Calltype
	public String callType(int t)	{
		
		if (t == 0)			return "Outgoing Call";
		else if (t == 1)	return "Incoming Call";
		else if (t == 2)	return "Missed Call";
		return null;

	}
	
	
	@Override
	public IBinder onBind(Intent intent) {
		return null;
	}
	
	@Override
	public void onCreate() {
		super.onCreate();
			
  		// Create Database
		db = new DBAdapter(getApplicationContext());
		
		
		// Declare all values, which need to be logged
		
		String date = new String();
		String time = new String();    	
		String name = new String();
		String phonenumber = new String();
		String duration = new String();
		String callclassification = new String();
		String d = new String();
		int e;
		
		
		
		// Collect new Phone Logs //
	  
		Cursor c = getContentResolver().query(
	               android.provider.CallLog.Calls.CONTENT_URI,
	               null,
	               null,
	               null,
	               android.provider.CallLog.Calls.DATE + " ASC");
 	   
		c.moveToFirst();
      
		date = formatDate.format(new Date());
		time = formatTime.format(new Date());
 	   	name = c.getString(c.getColumnIndex(CallLog.Calls.CACHED_NAME));
 	   	phonenumber = c.getString(c.getColumnIndex(CallLog.Calls.NUMBER));
 	   	d = c.getString(c.getColumnIndex(CallLog.Calls.DURATION));
 	   	duration = formatDuration(d);
 	   	e = c.getColumnIndex(CallLog.Calls.TYPE);
 	   	callclassification = callType(e);
  
  		Log.d(TAG, date);
  		Log.d(TAG, time);
  		Log.d(TAG, name);
  		Log.d(TAG, phonenumber);
  		Log.d(TAG, duration);
  		Log.d(TAG, callclassification);
  		
  		c.close();
  		
  		// Write new Phone Logs in Database //
	  
  		//db.open();
  		//db.insertCallLogs(date, time, name, phonenumber, duration, callclassification);
  		//db.close();
	
		
		// Collect call history + write into database (happens right after installation)
		
		//Log.d(TAG, "Log Collection is about to begin");
		/*
		Cursor c = getContentResolver().query(
						android.provider.CallLog.Calls.CONTENT_URI,
						null, null, null,
						android.provider.CallLog.Calls.DATE + " DESC");
						
						
		/* Retrieve the column-indices of required details */
/*
 		int nameColumn = c.getColumnIndex(android.provider.CallLog.Calls.CACHED_NAME);
		int numberColumn = c.getColumnIndex(android.provider.CallLog.Calls.NUMBER);
		int durationColumn = c.getColumnIndex(android.provider.CallLog.Calls.DURATION);
		int dateColumn = c.getColumnIndex(android.provider.CallLog.Calls.DATE);
		int typeColumn = c.getColumnIndex(android.provider.CallLog.Calls.TYPE);				
						
		/* Iterate through the whole history and save data on database */
		/*
		db.open();*/

		/*while(!c.isAfterLast())
		 		{
		 						String k = c.getString(dateColumn);
								name = c.getString(nameColumn);		 					
								phonenumber = c.getString(numberColumn);
								String d = c.getString(durationColumn);
								int callType = c.getInt(typeColumn);
		 		                switch(callType)	{
		                        	case android.provider.CallLog.Calls.INCOMING_TYPE:
										callclassification = "Incoming Call";
										break;
									case android.provider.CallLog.Calls.OUTGOING_TYPE:
										callclassification = "Outgoing Call";
										break;
								}
		 
		                      // Format date/time/duration
		 		              Date temp = null;
		 		              try {
		 		            	  temp = DateUtils.parseDate(k);
		 		              } catch (DateParseException e) {
								// Nothing
								e.printStackTrace();
		 		              }
		 		              
 							  date = formatDate.format(temp);
 							  time = formatTime.format(temp);
 							  duration = formatDuration(d);
 								  
							  // Write into database
			  				  db.insertCallLogs(date, time, name, phonenumber, duration, callclassification);
			  				  
			  				  // Move on to next entry
			  				  c.moveToNext();

		           } */
		
		/*  db.close();

		Log.d(TAG, "Log Collection has ended");*/

		  

	}
	     

	
	
	
	
	
}