package com.example.mylog;


import android.app.Activity;
import android.app.AlarmManager;
import android.app.PendingIntent;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.os.IBinder;
import android.os.SystemClock;
import android.telephony.PhoneStateListener;
import android.telephony.TelephonyManager;
import android.util.Log;



public class PhoneServiceReceiver extends Service {
	
	// Log-Tag for debugging
	private static final String TAG = PhoneService.class.getSimpleName();

	// Create Telephony + Listener variables
	public TelephonyManager telephony;
	public MyPhoneServiceListener phoneListener;
	
	@Override
	public IBinder onBind(Intent intent) {
		return null;
	}
	
	@Override
	public void onCreate() {
		super.onCreate();
		
	       // Put a Listener on the Phone-State

        telephony = (TelephonyManager)getSystemService(Context.TELEPHONY_SERVICE);
        phoneListener = new MyPhoneServiceListener();
        telephony.listen(phoneListener,PhoneStateListener.LISTEN_CALL_STATE);
		
	}
	
	
	private class MyPhoneServiceListener extends PhoneStateListener {



	// This method is a Listener on the Phone State: Whenever it changes --> a new query is made to Call Logs
		
		public void onCallStateChanged(int state, String incomingNumber)	{
		  
			Log.d(TAG, "STATE HAS CHANGED!");
	 	  
			// Register New Phone Logs  
		  
			switch(state){
		  		case TelephonyManager.CALL_STATE_IDLE:
		  			Log.d(TAG, "Phone is in idle state.");
		  			
		  			// Here comes the actual Service-Functionality
		  			
		  		    Intent pService = new Intent();
					pService.setAction("com.example.mylog.PhoneService");

		  			int sleep = 5000; // Waiting time before Log-database is accessed
		  			int flags = 0;
		  			
		  			PendingIntent piSync = PendingIntent.getService(getBaseContext(), 0, pService, flags);
		  		    Log.i(TAG, "schedulePendingSync: " + piSync.toString());
		  		    AlarmManager alarm = (AlarmManager) getBaseContext().getSystemService(Activity.ALARM_SERVICE);
		  		    alarm.set(AlarmManager.ELAPSED_REALTIME, SystemClock.elapsedRealtime() + sleep, piSync);

		  			// Endof Service-Functionality

		  			
		  			break;
		  		case TelephonyManager.CALL_STATE_OFFHOOK:
		  			Log.d(TAG, "Phone-User has initiated/accepted a call");
		  			break;
		  		case TelephonyManager.CALL_STATE_RINGING:
		  			Log.d(TAG, "Phone-User has received a call");
		  			break;
		  }
		   
	  }

	}
	
}